Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.core.task
Class SimpleAsyncTaskExecutor

    java.lang.Object
      org.springframework.util.CustomizableThreadCreator
          org.springframework.core.task.SimpleAsyncTaskExecutor

All Implemented Interfaces:
  java.io.Serializable, java.util.concurrent.Executor, AsyncTaskExecutor, TaskExecutor

    public class SimpleAsyncTaskExecutor

extends CustomizableThreadCreator
implements AsyncTaskExecutor, java.io.Serializable

`TaskExecutor` implementation that fires up a new Thread for each task, executing it asynchronously.

Supports limiting concurrent threads through the "concurrencyLimit" bean property. By default, the number of concurrent threads is unlimited.

NOTE: This implementation does not reuse threads! Consider a thread-pooling TaskExecutor implementation instead, in particular for executing a large number of short-lived tasks.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  `setConcurrencyLimit(int)`, `SyncTaskExecutor`, `ThreadPoolTaskExecutor`, `WorkManagerTaskExecutor`, Serialized Form

Field Summary
`static int` | `NO_CONCURRENCY` Switch concurrency 'off': that is, don't allow any concurrent invocations.
`static int` | `UNBOUNDED_CONCURRENCY` Permit any number of concurrent invocations: that is, don't throttle concurrency.

Fields inherited from interface org.springframework.core.task.AsyncTaskExecutor
`TIMEOUT_IMMEDIATE, TIMEOUT_INDEFINITE`

Constructor Summary
`SimpleAsyncTaskExecutor()` Create a new SimpleAsyncTaskExecutor with default thread name prefix.
`SimpleAsyncTaskExecutor(java.lang.String threadNamePrefix)` Create a new SimpleAsyncTaskExecutor with the given thread name prefix.
`SimpleAsyncTaskExecutor(java.util.concurrent.ThreadFactory threadFactory)` Create a new SimpleAsyncTaskExecutor with the given external thread factory.

Method Summary
`protected void` | `doExecute(java.lang.Runnable task)` Template method for the actual execution of a task.
`void` | `execute(java.lang.Runnable task)` Executes the given task, within a concurrency throttle if configured (through the superclass's settings).
`void` | `execute(java.lang.Runnable task, long startTimeout)` Executes the given task, within a concurrency throttle if configured (through the superclass's settings).
`int` | `getConcurrencyLimit()` Return the maximum number of parallel accesses allowed.
`java.util.concurrent.ThreadFactory` | `getThreadFactory()` Return the external factory to use for creating new Threads, if any.
`boolean` | `isThrottleActive()` Return whether this throttle is currently active.
`void` | `setConcurrencyLimit(int concurrencyLimit)` Set the maximum number of parallel accesses allowed.
`void` | `setThreadFactory(java.util.concurrent.ThreadFactory threadFactory)` Specify an external factory to use for creating new Threads, instead of relying on the local properties of this executor.
`
`<T> java.util.concurrent.Future<T>`
` | `submit(java.util.concurrent.Callable<T> task)` Submit a Callable task for execution, receiving a Future representing that task.
`java.util.concurrent.Future<?>` | `submit(java.lang.Runnable task)` Submit a Runnable task for execution, receiving a Future representing that task.

Methods inherited from class org.springframework.util.CustomizableThreadCreator
`createThread, getDefaultThreadNamePrefix, getThreadGroup, getThreadNamePrefix, getThreadPriority, isDaemon, nextThreadName, setDaemon, setThreadGroup, setThreadGroupName, setThreadNamePrefix, setThreadPriority`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### UNBOUNDED_CONCURRENCY

    public static final int UNBOUNDED_CONCURRENCY

  Permit any number of concurrent invocations: that is, don't throttle concurrency.

  See Also:
    Constant Field Values

### NO_CONCURRENCY

    public static final int NO_CONCURRENCY

  Switch concurrency 'off': that is, don't allow any concurrent invocations.

  See Also:
    Constant Field Values

Constructor Detail

### SimpleAsyncTaskExecutor

    public SimpleAsyncTaskExecutor()

  Create a new SimpleAsyncTaskExecutor with default thread name prefix.

### SimpleAsyncTaskExecutor

    public SimpleAsyncTaskExecutor(java.lang.String threadNamePrefix)

  Create a new SimpleAsyncTaskExecutor with the given thread name prefix.

  Parameters:
    `threadNamePrefix` - the prefix to use for the names of newly created threads

### SimpleAsyncTaskExecutor

    public SimpleAsyncTaskExecutor(java.util.concurrent.ThreadFactory threadFactory)

  Create a new SimpleAsyncTaskExecutor with the given external thread factory.

  Parameters:
    `threadFactory` - the factory to use for creating new Threads

Method Detail

### setThreadFactory

    public void setThreadFactory(java.util.concurrent.ThreadFactory threadFactory)

  Specify an external factory to use for creating new Threads, instead of relying on the local properties of this executor.

  You may specify an inner ThreadFactory bean or also a ThreadFactory reference obtained from JNDI (on a Java EE 6 server) or some other lookup mechanism.

  See Also:
    `CustomizableThreadCreator.setThreadNamePrefix(java.lang.String)`, `CustomizableThreadCreator.setThreadPriority(int)`

### getThreadFactory

    public final java.util.concurrent.ThreadFactory getThreadFactory()

  Return the external factory to use for creating new Threads, if any.

### setConcurrencyLimit

    public void setConcurrencyLimit(int concurrencyLimit)

  Set the maximum number of parallel accesses allowed. -1 indicates no concurrency limit at all.

  In principle, this limit can be changed at runtime, although it is generally designed as a config time setting. NOTE: Do not switch between -1 and any concrete limit at runtime, as this will lead to inconsistent concurrency counts: A limit of -1 effectively turns off concurrency counting completely.

  See Also:
    `UNBOUNDED_CONCURRENCY`

### getConcurrencyLimit

    public final int getConcurrencyLimit()

  Return the maximum number of parallel accesses allowed.

### isThrottleActive

    public final boolean isThrottleActive()

  Return whether this throttle is currently active.

  Returns:
    `true` if the concurrency limit for this instance is active
  See Also:
    `getConcurrencyLimit()`, `setConcurrencyLimit(int)`

### execute

    public void execute(java.lang.Runnable task)

  Executes the given task, within a concurrency throttle if configured (through the superclass's settings).

  Specified by:
    `execute` in interface `java.util.concurrent.Executor`
  Specified by:
    `execute` in interface `TaskExecutor`
  Parameters:
    `task` - the `Runnable` to execute (never `null`)
  See Also:
    `doExecute(Runnable)`

### execute

    public void execute(java.lang.Runnable task,
                        long startTimeout)

  Executes the given task, within a concurrency throttle if configured (through the superclass's settings).

  Executes urgent tasks (with 'immediate' timeout) directly, bypassing the concurrency throttle (if active). All other tasks are subject to throttling.

  Specified by:
    `execute` in interface `AsyncTaskExecutor`
  Parameters:
    `task` - the `Runnable` to execute (never `null`)
    `startTimeout` - the time duration (milliseconds) within which the task is supposed to start. This is intended as a hint to the executor, allowing for preferred handling of immediate tasks. Typical values are `AsyncTaskExecutor.TIMEOUT_IMMEDIATE` or `AsyncTaskExecutor.TIMEOUT_INDEFINITE` (the default as used by `TaskExecutor.execute(Runnable)`).
  See Also:
    `AsyncTaskExecutor.TIMEOUT_IMMEDIATE`, `doExecute(Runnable)`

### submit

    public java.util.concurrent.Future<?> submit(java.lang.Runnable task)

  Description copied from interface: `AsyncTaskExecutor`
  Submit a Runnable task for execution, receiving a Future representing that task. The Future will return a `null` result upon completion.

  Specified by:
    `submit` in interface `AsyncTaskExecutor`
  Parameters:
    `task` - the `Runnable` to execute (never `null`)
  Returns:
    a Future representing pending completion of the task

### submit

    public <T> java.util.concurrent.Future<T> submit(java.util.concurrent.Callable<T> task)

  Description copied from interface: `AsyncTaskExecutor`
  Submit a Callable task for execution, receiving a Future representing that task. The Future will return the Callable's result upon completion.

  Specified by:
    `submit` in interface `AsyncTaskExecutor`
  Parameters:
    `task` - the `Callable` to execute (never `null`)
  Returns:
    a Future representing pending completion of the task

### doExecute

    protected void doExecute(java.lang.Runnable task)

  Template method for the actual execution of a task.

  The default implementation creates a new Thread and starts it.

  Parameters:
    `task` - the Runnable to execute
  See Also:
    `setThreadFactory(java.util.concurrent.ThreadFactory)`, `CustomizableThreadCreator.createThread(java.lang.Runnable)`, `Thread.start()`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD